<?php
namespace nur\sery\schema\types;

use nur\sery\schema\input\Input;
use nur\sery\schema\Result;

/**
 * Interface IType: un type de données
 */
interface IType {
  /** ce type peut-il analyser la donnée dans $input[$destKey] ? */
  function canAnalyze(Input $input, $destKey): bool;

  /** la donnée $input[$destKey] est-elle disponible? */
  function isAvailable(Input $input, $destKey): bool;

  /** la valeur $value est-elle nulle? */
  function isNull($value): bool;

  /** la valeur $value est-elle valide et normalisée le cas échéant? */
  function isValid($value, ?bool &$normalized=null): bool;

  /**
   * analyser, corriger éventuellement et normaliser la valeur
   *
   * si la valeur était déjà normalisée, retourner false.
   */
  function verifix(&$value, Result &$result): bool;

  /** formatter la valeur pour affichage */
  function format($value, $format=null): string;
}
